import { world } from "@minecraft/server";

/** @type {import("@minecraft/server").BlockCustomComponent} */
const PafaGlassWindowActivityComponent = {
    onPlayerInteract(
        { 
            block, 
            dimension 
        }
    ) {
        const isOpen = block.permutation.getState("pafa:windows_open");
        const sound = isOpen ? "close.wooden_trapdoor" : "open.wooden_trapdoor";
        block.setPermutation(block.permutation.withState("pafa:windows_open", !isOpen));
        dimension.playSound(
            sound, block.center(), {
                pitch: 0.9,
                volume: 0.9,
            }
        );
    }
};

world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry }) => {
    blockComponentRegistry.registerCustomComponent(
        "pafa:windows_open_compo",
        PafaGlassWindowActivityComponent
    )
});